/*-
 * Copyright (c) 2009 OKA Shinichiro.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <cstring>

#include "Bufsink.hpp"


void
Bufsink::put(const uint8_t *buf, int32_t len)
{
	// ɤ߹Ĥȹ碌ƤХåե­ʤ
	if (sizeof(_buf) > _buf_used + len) {
		memcpy(&_buf[_buf_used], buf, len);
		_buf_used += len;
		return;
	}

	// ɤ߹Ĥ꤬
	if (_buf_used > 0) {
		int chunk = (sizeof(_buf) - _buf_used);
		memcpy(&_buf[_buf_used], buf, chunk);
		_sink->put(_buf, sizeof(_buf));

		buf += chunk;
		len -= chunk;
	}

	// ХåեȤޤȤƼή
	while (len >= sizeof(_buf)) {
		_sink->put(buf, sizeof(_buf));

		buf += sizeof(_buf);
		len -= sizeof(_buf);
	}

	// ǸΥХåե̤ΥǡϿ
	if (len > 0)
		memcpy(&_buf[0], buf, len);
	_buf_used = len;
}

// ХåեΥեå
void
Bufsink::flush()
{
	// ǡ򼡤äƤ
	_sink->put(_buf, _buf_used);
	_buf_used = 0;

	_sink->flush();
}

void
Bufsink::setChain(Datasink* sink)
{
	_sink = sink;
}
