/*-
 * Copyright (c) 2009 OKA Shinichiro.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _BUFSINK_HPP_
#define _BUFSINK_HPP_

#include <sys/types.h>
#include <inttypes.h>
#include <cstdio>

#include "Datasink.hpp"

// Decryptǡ188byteñ̤ήƤΤǡ
// ٤ޤȤƼήΥХåե
class Bufsink : public Datasink
{
public:
	virtual void put(const uint8_t *buf, int32_t len);
	virtual void flush();

	Bufsink() : _sink(NULL), _buf_used(0) {}
	virtual ~Bufsink() {}

	void setChain(Datasink* sink);

private:
	Datasink* _sink;

	uint8_t _buf[512 * 4]; // Хåե2kb
	int _buf_used;
};
#endif //!_BUFSINK_HPP_
