/*-
 * Copyright (c) 2009 OKA Shinichiro.
 * All rights reserved.
 * Copyright (c) 2008 FUKAUMI Naoki.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _HDUS_HPP_
#define _HDUS_HPP_

#include <inttypes.h>
#include <aio.h>

#include <libusb20_desc.h>

class Hdus
{
public:
	void open() throw (const char*);
	void close();
	void init();
	uint8_t asie5606(int null);
	void setfreq(int freq, int xpid_min, int xpid_max);
	void start();
	void stop(uint8_t saddr);

	void record(int duration, const char* outfile, int w_b25);

	Hdus() : _ep0(-1), _ep1(-1) {}

private:
	int send_ctl(uint8_t *data, int req, int val, int idx, int len);

	bool is_hdus(struct libusb20_device *pdev);
	void open_hdus(struct libusb20_device *pdev);

	int _ep0; // for control
	int _ep1; // for read
};
#endif //!_HDUS_HPP_
